package com.nisum.paymentvendorsimulator.paypal.services;

import com.nisum.paymentvendorsimulator.paypal.domain.dto.PayPalAmount;
import com.nisum.paymentvendorsimulator.paypal.domain.dto.PayPalLink;
import com.nisum.paymentvendorsimulator.paypal.domain.dto.PayPalResponse;
import com.nisum.paymentvendorsimulator.paypal.domain.dto.PayPalSellerProtection;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.Arrays;

@Service
public class PayPalService {

  public PayPalResponse authorize(String id) {

    return new PayPalResponse(
            id,
            "CREATED",
            new PayPalAmount("10.99", "USD"),
            "INVOICE-123",
            new PayPalSellerProtection("ELIGIBLE", Arrays.asList("ITEM_NOT_RECEIVED", "UNAUTHORIZED_TRANSACTION")),
            LocalDateTime.of(2019, 10, 10, 23, 23, 45),
            LocalDateTime.of(2017, 10, 10, 23, 23, 45),
            LocalDateTime.of(2018, 10, 10, 23, 23, 45),
            Arrays.asList(
                    new PayPalLink("self","GET", "https://api-m.paypal.com/v2/payments/authorizations/" + id ),
                    new PayPalLink("capture","POST", "https://api-m.paypal.com/v2/payments/authorizations/" + id + "/capture" )
            )
    );
  }
}
